package xlogo.gui;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.awt.event.MouseMotionAdapter;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.Point;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import xlogo.Config;
/**
 * Title :        XLogo
 * Description :  XLogo is an interpreter for the Logo 
 * 						programming language
 * @author Loïc Le Coq
 */

public class Ardoise extends JPanel{
	private int bouton_souris=0;  	// Numéro du bouton de souris appuyé sur la zone de dessin
	private String possouris="[ 0 0 ] ";	// Coordonnées du point du dernier événement souris
	public static BufferedImage dessin;
	private JScrollPane scroll;
	private	Click_Souris cs=new Click_Souris();
	private Bouge_Souris bs=new Bouge_Souris();
	private boolean lissouris=false; //Indique si un événement souris est intervenu depuis le debut du programme
  public Ardoise() {
  }
  public Ardoise(JScrollPane scroll){
    this.scroll=scroll;
    this.setPreferredSize(new Dimension(Config.imageWidth, Config.imageHeight));
    }
 
  public void paint(Graphics g){
    super.paint(g);
    try{
      g.setClip(scroll.getViewport().getViewRect());
      g.drawImage(dessin,0,0,this);
   }
   catch(java.lang.NullPointerException e){}
  }
	 public void active_souris(){
		 lissouris=false;
		 addMouseListener(cs);
		 addMouseMotionListener(bs);
	 }
	 public void stop_souris(){
		 removeMouseListener(cs);
		 removeMouseMotionListener(bs);
	 }
	 public boolean get_lissouris(){
		 return lissouris;
	 }
	 public int get_bouton_souris(){
		 lissouris=false;
		 return bouton_souris;
	 }
	 public String get_possouris(){
		 lissouris=false;
		 return possouris;
	 }
	/* public BufferedImage getDessin(){
	 	return dessin;	
	 }
	 public void setDessin(BufferedImage bi){
	 	dessin=bi;
	 }*/ 
	 class Click_Souris extends MouseAdapter{
		 public void mouseClicked(MouseEvent ev){
			 lissouris=true;
			 bouton_souris=ev.getButton();
			 Point point=ev.getPoint();
			 possouris="[ "+(point.x-Config.imageWidth/2)+" "+(Config.imageHeight/2-point.y)+" ] ";
		 }
   }
   class Bouge_Souris extends MouseMotionAdapter{
		 public void mouseMoved(MouseEvent ev){
			 lissouris=true;
			 bouton_souris=0;
			 Point point=ev.getPoint();
			 possouris="[ "+(point.x-Config.imageWidth/2)+" "+(Config.imageHeight/2-point.y)+" ] ";
		 }
	 }
}